From 11bbaff47004eb464caee94626ccbf6902e4935c Mon Sep 17 00:00:00 2001
From: Stephanie Buser <sbuser@codeaurora.org>
Date: Tue, 3 Jul 2018 12:31:15 -0700
Subject: [PATCH] Minor fixes in the IPC Router

---
 drivers/soc/qcom/ipc_router_usb_xprt.c | 27 ++++++++++++++++++++++-----
 drivers/usb/misc/ipcrtr.c              |  6 ++++--
 2 files changed, 26 insertions(+), 7 deletions(-)

diff --git a/drivers/soc/qcom/ipc_router_usb_xprt.c b/drivers/soc/qcom/ipc_router_usb_xprt.c
index 135db23..cc86eda 100644
--- a/drivers/soc/qcom/ipc_router_usb_xprt.c
+++ b/drivers/soc/qcom/ipc_router_usb_xprt.c
@@ -287,11 +287,17 @@ static int msm_ipc_router_usb_remote_close(
 	if (!usb_xprtp)
 		return -EINVAL;
 
+	if (!usb_xprtp->xprt_avail) {
+		IPC_RTR_ERR("%s: xprt is not available\n", __func__);
+		return -EINVAL;
+	}
+
 	mutex_lock(&usb_xprtp->xprt_lock);
 	usb_xprtp->xprt_avail = 0;
 	mutex_unlock(&usb_xprtp->xprt_lock);
 	flush_workqueue(usb_xprtp->usb_xprt_wq);
 	destroy_workqueue(usb_xprtp->usb_xprt_wq);
+	usb_xprtp->usb_xprt_wq = NULL;
 	if (usb_xprtp->ops && usb_xprtp->ops->close)
 		usb_xprtp->ops->close();
 	return 0;
@@ -315,8 +321,11 @@ static void usb_xprt_read_data(struct work_struct *work)
 	struct delayed_work *rwork = to_delayed_work(work);
 	struct msm_ipc_router_usb_xprt *usb_xprtp =
 		container_of(rwork, struct msm_ipc_router_usb_xprt, read_work);
-	if (!usb_xprtp)
-		return -EINVAL;
+
+	if (unlikely(!usb_xprtp)) {
+		IPC_RTR_ERR("%s: USB Xprt NULL pointer\n", __func__);
+		return;
+	}
 
 	while (1) {
 		while (!usb_xprtp->in_pkt) {
@@ -409,9 +418,6 @@ static void usb_xprt_sft_close_done(struct msm_ipc_router_xprt *xprt)
 	struct msm_ipc_router_usb_xprt *usb_xprtp =
 		container_of(xprt, struct msm_ipc_router_usb_xprt, xprt);
 
-	if (!usb_xprtp)
-		return -EINVAL;
-
 	if (unlikely(!usb_xprtp)) {
 		IPC_RTR_ERR("%s: USB Xprt NULL pointer ",__func__);
 		return;
@@ -448,11 +454,17 @@ int msm_ipc_router_usb_ipc_xprt_unregister(struct usb_ipc_xprt_ops *xprt_ops)
 		return -EINVAL;
 	}
 
+	if (!usb_xprtp->xprt_avail) {
+		IPC_RTR_ERR("%s: USB Xprt not available\n", __func__);
+		return -EINVAL;
+	}
+
 	mutex_lock(&usb_xprtp->xprt_lock);
 	usb_xprtp->xprt_avail = 0;
 	mutex_unlock(&usb_xprtp->xprt_lock);
 	flush_workqueue(usb_xprtp->usb_xprt_wq);
 	destroy_workqueue(usb_xprtp->usb_xprt_wq);
+	usb_xprtp->usb_xprt_wq = NULL;
 	init_completion(&usb_xprtp->sft_close_complete);
 	msm_ipc_router_xprt_notify(&usb_xprtp->xprt,
 				   IPC_ROUTER_XPRT_EVENT_CLOSE, NULL);
@@ -514,7 +526,10 @@ int msm_ipc_router_usb_ipc_xprt_register(struct usb_ipc_xprt_ops *xprt_ops)
 		IPC_RTR_ERR("%s: Channel open failed for %s xprt\n",
 			__func__, MODULE_NAME);
 		destroy_workqueue(usb_xprtp->usb_xprt_wq);
+		usb_xprtp->usb_xprt_wq = NULL;
+		mutex_lock(&usb_xprtp->xprt_lock);
 		usb_xprtp->xprt_avail = 0;
+		mutex_unlock(&usb_xprtp->xprt_lock);
 		return rc;
 	}
 
@@ -763,6 +778,8 @@ static int msm_ipc_usb_xprt_debugfs_init(void)
 	debugfs_create_file("stats", S_IRUSR | S_IRGRP | S_IROTH, debugfs_root,
 				usb_xprt_ctx, &fops_usb_ipc_xprt);
 	DBG("%s: debugfs created %p \n",__func__, debugfs_root);
+
+	return 0;
 }
 
 static void msm_ipc_usb_xprt_debugfs_exit(void)
diff --git a/drivers/usb/misc/ipcrtr.c b/drivers/usb/misc/ipcrtr.c
index bb7357e..78480b6 100644
--- a/drivers/usb/misc/ipcrtr.c
+++ b/drivers/usb/misc/ipcrtr.c
@@ -448,8 +448,10 @@ ipcrtr_ctrl_read(char *buf, unsigned int count)
 		goto done;
 	}
 
-	if (!atomic_read(&ipcrtr_ctx->connected))
-		return -ECONNRESET;
+	if (!atomic_read(&ipcrtr_ctx->connected)) {
+		ret = -ECONNRESET;
+		goto done;
+	}
 
 	pr_debug("%s - Packet Received Usb\n",__func__);
 	spin_lock_irqsave(&ipcrtr_ctx->lock, flags);
-- 
2.9.5

